<?php
    // Data handling section
    if($_POST['srslide_save_hidden'] == 'Y') {
        $srpid = $_POST['srslide_pid'];
        update_option('srslide_pid', $srpid);
        ?>
        <div class="updated"><p><strong><?php _e('Options saved.'); ?></strong></p></div>
        <?php
    } else if ($_POST['srslide_register_hidden'] == 'Y') {

        // Setup the encoded params from the $_POST
        $encoded_params = '';
        foreach($_POST as $name => $value) {
            // Only pass vars that start with srslide_sr
            if (!preg_match('/^srslide_sr_.+/',$name)) { next; }
            $encoded_params .= urlencode($name).'='.urlencode($value).'&';
        }

        // Get the blog name
        $encoded_params .= 'account_name='.urlencode(get_option('blogname')).'&';
        // Get the site URL
        $encoded_params .= 'website='.urlencode(get_option('siteurl')).'&';
        $encoded_params .= 'ts='.(int)gmdate('U').'&';

        // Remove the last '&'
        $encoded_params = substr($encoded_params, 0, strlen($encoded_params)-1);

        // Curl call for registration
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, "https://www.simplereach.com/publisher/wp_create");
        curl_setopt($curl, CURLOPT_POST, count(explode('&',$encoded_params)));
        curl_setopt($curl, CURLOPT_POSTFIELDS, $encoded_params);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        $curl_resp = curl_exec($curl);
        curl_close($curl);

        // Decode the JSON
        $resp = json_decode($curl_resp);

        if ($resp->{'success'}) {
            // Save the username, password, and PID to WP
            update_option('srslide_pid',$resp->{'success'});
            update_option('srslide_sr_login',$_POST['srslide_sr_login']);
            update_option('srslide_sr_pass',$_POST['srslide_sr_pass']);
            update_option('srslide_registered',true);
            ?>
                <div id="message" class="updated below-h2"><p>
                    <?php _e('Congratulations, your SimpleReach account has been successfully created!') ?>
                </p></div>
            <?php
        } else {
            ?>
                <div id="message" class="updated below-h2"><p>
            <?php
                _e("We were not able to register you: ");
                if ($resp->{'error'} == 'Invalid Domain') {
                    _e("This domain has already been registered. Please contact <a href='mailto:support@simplereach.com'>SimpleReach support</a> if you believe you have received this message in error.");
                } else if ($resp->{'error'} == 'Incorrect Timestamp') {
                    _e("There was an error while you were attempting to register. Please try again or contact <a href='mailto:support@simplereach.com'>SimpleReach support</a> if you believe you have received this message in error.");
                } else if ($resp->{'error'} == 'Invalid Password') {
                    _e("The user name that you are attempting to register with already exists, but the password you entered was incorrect. Please try again or contact <a href='mailto:support@simplereach.com'>SimpleReach support</a> if you believe you have received this message in error.");
                } else {
                    _e("An unknown error has been encountered. Please try again or contact <a href='mailto:support@simplereach.com'>SimpleReach support</a>.");
                }
            ?>
                </p></div>
            <?php
            update_option('srslide_registered',false);
        }
    }

    // Is the publisher a registered SimpleReach user
    $sr_is_registered = get_option('srslide_registered');
    if ($sr_is_registered) {
        // Part of our normal page display
        $srpid = get_option('srslide_pid');
        $srlogin = get_option('srslide_sr_login');
        $debug_info = create_debug_info();
    }
?>

<div class="wrap">
    <?php echo "<h2>" . __( 'SimpleReach Slide Settings', 'srslide_adminopt' ) . "</h2>"; ?>

    <?php if ($sr_is_registered) { ?>

        <p>
            <?php _e("You are already registered with SimpleReach."); ?>
        </p>
        <p>
            <?php _e("To access your Reporting/Analytics dashboard, log in to "); ?><a href="https://www.simplereach.com">simplereach.com</a>.
        </p>
        <p>
            <?php _e("To learn how to customize the style and/or functionality of The Slide, click "); ?><a href="https://www.simplereach.com/docs/publisher/overview"><?php _e("here"); ?></a>.
        </p>
        <p>
            <?php _e("If you have any questions, please don't hesitate to"); ?>
            <a href="https://www.simplereach.com/contact?r=support&e=<?php echo urlencode($srlogin); ?>&debug_info=<?php echo urlencode($debug_info); ?>#reach-out"><?php _e("contact us"); ?></a>!
        </p>

    <?php } else { ?>

        <p><strong><?php _e("Register for a SimpleReach account. If you have already registered at simplereach.com, enter your login information below.") ?></strong></p>
        <form name="srslide_form" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
          <input type="hidden" name="srslide_register_hidden" value="Y">

            <table style='border:0px;margin-top:20px;' cellspacing='10'>
              <tr>
                <td style="text-align:right;width:70px;"><?php _e("Email: " ); ?></td>
                <td><input type="text" name="srslide_sr_login" value="<?php echo $sr_login; ?>" size="35"></td>
                <td><?php _e(" ex: user@example.com" ); ?></td>
              </tr>
              <tr>
                <td style="text-align:right;width:70px;"><?php _e("Password: " ); ?></td>
                <td><input type="password" name="srslide_sr_pass" value="<?php echo $sr_password; ?>" size="35"></td>
                <td><?php _e(" ex: secretpass" ); ?></td>
              </tr>
              <tr>
                <td>&nbsp;</td>
                <td style='text-align:right'><input style="margin-top:10px;" type="submit" name="Submit" value="<?php _e('Register', 'srslide_adminopt' ); ?>" /></td>
                <td>&nbsp;</td>
              </tr>
            </table>

        </form>

    <?php } ?>
</div>
