<?php

/**
 * Put together some debug info to send to SimpleReach when support
 * is requested.
 *
 * @author Eric Lubow <elubow@simplereach.com>
 * @param None
 * @return String Debug info
 */
function create_debug_info()
{
    $rv = "";
    $rv .= "PID: ".get_option('srslide_pid')."\n";
    $rv .= "Email: ".get_option('srslide_sr_login')."\n";
    $rv .= "Website: ".get_option('siteurl')."\n";
    $rv .= "Account: ".get_option('blogname')."\n";
    $rv .= "WP Version: ".get_bloginfo('version')."\n";

    return $rv;
}

/**
 * Return the SimpleReach title for the post.
 *
 * @author Eric Lubow <elubow@simplereach.com>
 * @param Object $post Post object being shown on the page
 * @return String Title of the post with slashes escaped
 */
function get_sr_post_title($post)
{
    $title = get_post_meta($post->ID,'_srslide_title',true);

    if (!isset($title) || empty($title)) {
        $title = $post->post_title;
    }

    return addslashes($title);
}


/**
 * Return the SimpleReach tags for the post.
 *
 * @author Eric Lubow <elubow@simplereach.com>
 * @param Object $post Post object being shown on the page
 * @return String Tags of the post with slashes escaped
 */
function get_sr_post_tags($post)
{
    $tags = get_post_meta($post->ID,'_srslide_tags',true);

    if (!isset($tags) || empty($tags)) {
        $wptags = wp_get_post_tags($post->ID);
        foreach ($wptags as $tag) {
            $tags .= addslashes($tag->name) . ",";
        }
        $tags = rtrim($tags,",");
    }

    return $tags;
}

?>
